################################################################################
##
## Remote Http Administration script v0.2
##
################################################################################

################################################################################
# Intro:
#
#  - This script has a http server that is able to transfer binairy files
#    images and so on, included http admin script, with dynamic executable 
#    langue (tcl) supports file extentions: js, txt, htcl, html, htm, css, jpg,
#    gif, gz, tar, zip, exe, will add more types in the future. 
#  - It has save user file md5 pass hash, auth with dynamic hash, it has daily, 
#    hostbased hashes and one that is added random like this even when you are 
#    accessing your bot from a public place, day after they won't be allowed to 
#    access, your bot from url history, also have to option to reset your hash,
#    witch means it has instant effect, .. no one will be able to steal the
#    links from your computer or any, cause there is a daily hash change.
#  - Even if they are able to access your http-auth access file they still
#    can't use it cause its md5 encrypted witch is nearly impossible to crack.
#
# Features:
#
# Addusers .addusr <username> <password> (dcc command)
# Delusers .delusr <username> (dcc command)
# Resetting random md5 hash .chhash (dcc command)
#
# Install:
#  - Put HttpAdmin.tcl in scripts dir and add this to your config file
#    "source scripts/HttpAdmin.tcl" without quotes.
#  - Put wwwroot in your main eggdrop dir.
#  - Check the config below and rehash bot addusers and you're set to go. 
#
# Changelog:
#  - 15/07/2004: 
#     Changed CRLF to unix file type, added ico webserver support & Added ico 
#     to the "inc/header.htcl" & "index.htcl".
#
#  - 17/07/2004
#     inc/menu-footer.htcl htmlfix 
#     inc/footer.htcl inserted dropdown + reorganized code
#     inc/header.htcl inserted dropdown + reorganized code
#     dyn.htcl inserted dropdown + htmlfixes
#     inc/script.js inserted dropdown
#     inc/menuheader.htcl htmlfix
#
#  - 18/07/2004
#     footer.htcl dropdown style changes
#     header.htcl dropdown style changes
#     dyn.htcl codecleanup + dropdown style changes
#
#  - 20/07/2004
#     dyn.htcl Styles channels menu fix + invalid channel flags.
#     HttpAdmin.tcl invalid channel flags + invalid http root error.
#     footer.htcl added dropdown channels menu
#     header.htcl added dropdown channels menu
#
#  - 21/07/2004 
#     dyn.htcl html fixes + chanlist html cleanup
#     header.htcl invalid char mapping
#     menu-header.htcl invalid char mapping
#
#  - 21/07/2004
#     dyn.htcl Dropmenus nick2hand + added user chan flags indicator.
#     header.htcl Dropmenus nick2hand.
#
#  - 21/07/2004 
#     HttpAdmin.tcl Added more invalid string values
#     dyn.htcl Added more invalid string values
#     header.htcl Added more invalid string values
#     menu-header.htcl Added more invalid string values
#
################################################################################

################################################################################
# TCL scripts by Ofloo all rights reserved.
#
# HomePage: http://ofloo.net/
# CVS: http://cvs.ofloo.net/
# Email: support[at]ofloo.net
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
################################################################################

##############################
# Java :tested with brouwsers
# 
# Login md5 encryption:
#
# Explorer 6.x works
# Lynx does not work
# Galeon 1.3.8 works
# Konqueror works
# Mozilla works
# Opera not tested
#
##############################

##############################
# The www root dir
##############################

set http(root) "wwwroot"

##############################
# Http ports
##############################

set http(port) "8080"

##############################
# The webservers name
##############################

set http(server) "Eggdrop web server by Ofloo"

##############################
# Echo lag checks to the 
# party line .. 1 yes 0 no
##############################

set http(loglag) "0"

##############################
# Script version do not edit 
##############################

set http(version) "0.1"
set http(extension) ".htcl"
set http(authfile) "$http(root)/inc/http-auth"
set http(conf) "$config"
set http(eversion) "$version"
set http(euptime) "$uptime"
set http(handlen) "$handlen"
set http(servers) "$servers"
set http(random) "[rand 99999]"

################################################################################

bind time - "00 * * * *" time:event
bind raw - 391 raw:lagchecker
bind evnt - init-server event:connect
bind evnt - disconnect-server event:disconnect
bind dcc n chhash chhash:dcc
bind dcc n addusr addusr:dcc
bind dcc n delusr delusr:dcc

################################################################################

############################## 
# Valid dir check & and dir
# exists check.
##############################

if {![file exists $http(root)] || ![file isdirectory $http(root)]} {
   putlog "Can not locate the \(\002$http(root)\002\), or this is not a valid directory. Plz config HttpAdmin.tcl as it should, Thank You."
   return 
}

##############################
# Events on disconnect this 
# unsets the lag variables
##############################

proc event:disconnect {type} {
  global lag http web
  array unset lag
  unset web(lagcheck)
}

##############################
# Event on connect this sends
# a check request for lag
# And checks the online or 
# offline status of the 
# servers.
##############################

proc event:connect {type} {
  global lag http
  set lag(start) [clock clicks -milliseconds]
  putserv "TIME"
  foreach x [lindex [split $http(servers) \n] 0] { 
    set x [lindex $x 0]
    portcheck [lindex [split $x \x3A] 0] [lindex [split $x \x3A] 1]
  }
}

##############################
# This will perfrom lagcheck
# and check online offline
# status of the servers in 
# set servers {} of your
# eggdrops config
##############################

proc time:event {min hour day month year} {
  global lag http
  set lag(start) [clock clicks -milliseconds]
  putserv "TIME"
  foreach x [lindex [split $http(servers) \n] 0] { 
    set x [lindex $x 0]
    portcheck [lindex [split $x \x3A] 0] [lindex [split $x \x3A] 1]
  }
}

##############################
# This is a raw bind by 
# sending a time request and
# setting a global time then 
# calc on how long it takes
# for the server to reply
# well result is lag time ;)
##############################

proc raw:lagchecker {from key arg} {
  global lag http
  set lag(result) [format %.2f [expr ([clock clicks -milliseconds]-$lag(start))/2000.0]]
  if {($http(loglag))} {
    putlog "Current lag \(\002$lag(result)\002\)."
  }
}

##############################
# Proc that opens the web
# server ports
##############################

if {![info exists http(socket)]} {
  socket -server httpserver $http(port)
  set http(socket) 1
}

##############################
# Http server
##############################

proc httpserver {s ipaddr port} {
  global http data server botnick botnet-nick tcl_platform server-online uptime lag online
  fconfigure $s -blocking 0 -buffering line
  set smstime [clock clicks -milliseconds]
  gets $s x
  set i 0
  set info($i) $x
  incr i
  while {$i<20} {
    gets $s info($i)
    incr i
  }
  unset i
  if {![string match -nocase */\.\.* [lindex $x 1]] && ([string equal -nocase "get" [lindex $x 0]] || [string equal -nocase "post" [lindex $x 0]])} {
    if {[string match -nocase "*$http(extension)\x3F*" [lindex $x 1]]} {
      set getfile [lindex [split [lindex $x 1] \x3F] 0]
      set arg [lindex [split [lindex $x 1] \x3F] 1]
      foreach a [split $arg \x26] {
        set web([string map {%23 \x23 %21 \x21 %3F \x3F %2A \x2A %2E \x2E %5C \\ %28 \( %29 \) %5B \[ %5D \] %7B \{ %7D \} %24 \$ %22 \" %25 \% \\ \\\\ \[ \\\[ \] \\\] \{ \\\{ \} \\\} \" \\\" \( \\\( \) \\\) \# \\\# \$ \\\$} [lindex [split $a \x3D] 0]]) "[join [lrange [string map {%23 \x23 %21 \x21 %3F \x3F %2A \x2A %2E \x2E %5C \\ %28 \( %29 \) %5B \[ %5D \] %7B \{ %7D \} %24 \$ %22 \" %25 \% \\ \\\\ \[ \\\[ \] \\\] \{ \\\{ \} \\\} \" \\\" \( \\\( \) \\\) \# \\\# \$ \\\$} [split [lindex [split $a \x3D] 1] \x2B]] 0 end]]"
      }
    } elseif {[string equal -nocase "/" [lindex $x 1]]} {
      set getfile "/index.htcl"
    } else {
      set getfile [lindex $x 1]
    }
    if {[string equal -nocase "$http(extension)" [file extension "$getfile"]]} {
      if {[file exists $http(root)$getfile]} {
        puts $s "\
	            HTTP/1.1 200 OK\n\
	            Date: [clock format [clock seconds] -format {%a, %d %b %Y %T GMT} -gmt 1]\n\
	            Server: Eggdrop http script by Ofloo\n\
		    Content-Type: text/html; charset=iso-8859-1\n\
		    Cache-Control: no-cache; no-store; max-age=0\n\
		    Pragma: no-cache\n"
	catch [source $http(root)$getfile] error
	if {![string match -nocase {} $error]} {
	  putlog "Error within \(\002$getfile\002\) file \(\002$error\002\)."
	}
      } else {
        putlog "Error 404 \(\002$getfile\002\) does not exist."
        ERROR404 $smstime $s
      }
    } elseif {[string equal -nocase ".js" [file extension "$getfile"]] ||\
              [string equal -nocase ".css" [file extension "$getfile"]] ||\
	      [string equal -nocase ".html" [file extension "$getfile"]] ||\
	      [string equal -nocase ".htm" [file extension "$getfile"]] ||\
	      [string equal -nocase ".txt" [file extension "$getfile"]]\
    } {
      if {[file exists $http(root)$getfile]} {
        puts $s "HTTP/1.1 200 OK\n\
	            Date: [clock format [clock seconds] -format {%a, %d %b %Y %T GMT} -gmt 1]\n\
	            Server: Eggdrop http script by Ofloo\n\
		    Last-Modified: [clock format [file atime $http(root)$getfile] -format {%a, %d %b %Y %T GMT}]\n\
		    Accept-Ranges: bytes\n\
		    Content-Type: text/html; charset=iso-8859-1\n"
        set rf [open "$http(root)$getfile" r]
        foreach data [split [read $rf] \n] {
          puts $s "[stripvars [string map {\\ \\\\ \[ \\\[ \] \\\] \{ \\\{ \} \\\} \" \\\" \( \\\( \) \\\)} $data]]"
        }
	close $rf
      } else {
        putlog "Error 404 \(\002$getfile\002\) does not exist."
        ERROR404 $smstime $s
      }
    } elseif {[string equal -nocase ".zip" [file extension "$getfile"]] ||\
              [string equal -nocase ".tar" [file extension "$getfile"]] ||\
	      [string equal -nocase ".gz" [file extension "$getfile"]] ||\
	      [string equal -nocase ".exe" [file extension "$getfile"]] ||\
	      [string equal -nocase ".tar" [file extension "$getfile"]] ||\
	      [string equal -nocase ".gif" [file extension "$getfile"]] ||\
	      [string equal -nocase ".ico" [file extension "$getfile"]] ||\
	      [string equal -nocase ".jpg" [file extension "$getfile"]]\
    } {
      if {[file exists $http(root)$getfile]} {
        set ext [file extension "$getfile"]
	if {[string equal -nocase ".zip" $ext]} {
          set type "application/zip"
	} elseif {[string equal -nocase ".tar" $ext]} {
	  set type "application/x-tar"
	} elseif {[string equal -nocase ".gif" $ext]} {
	  set type "image/gif"
	} elseif {[string equal -nocase ".exe" $ext]} {
	  set type "application/x-msdos-program"
	} elseif {[string equal -nocase ".jpg" $ext]} {
	  set type "image/jpeg"
	} elseif {[string equal -nocase ".gz" $ext]} {
	  set type "application/x-tar\nContent-Encoding: x-gzip"
	} elseif {[string equal -nocase ".ico" $ext]} {
	  set type "text/plain; charset=iso-8859-1"
	}

        puts $s "\
	HTTP/1.1 200 OK\n\
        Date: [clock format [clock seconds] -format {%a, %d %b %Y %T GMT} -gmt 1]\n\
        Server: Eggdrop http script by Ofloo\n\
        Last-Modified: [clock format [file atime $http(root)$getfile] -format {%a, %d %b %Y %T GMT}]\n\
        Accept-Ranges: bytes\n\
        Connection: close\n\
        Content-Type: $type\n"

        set rf [open "$http(root)$getfile" r]
	fconfigure $rf -translation binary
	fconfigure $s -translation binary
	puts $s "[read $rf]"
	close $rf
      } else {
        putlog "Error 404 \(\002$getfile\002\) does not exist."
        ERROR404 $smstime $s
      }
    } else {
      putlog "Error 400 \(\002$getfile\002\) bad request from \(\002$ipaddr\002\)."
      ERROR400 $smstime $s
    }
  } else {
    putlog "Error 400 \(\002[lindex $info(0) 1]\002\) bad request from \(\002$ipaddr\002\)."
    ERROR400 $smstime $s
  }
  close $s
}

##############################
# Resolves variables from 
# html file.
##############################

proc stripvars {arg} {
  global http
  set arg [string map {\\ \\\\ \[ \\\[ \] \\\] \{ \\\{ \} \\\} \" \\\" \( \\\( \) \\\)} $arg]
  set arg [join [lrange [string map [list %SERVERNAME% $http(server)] $arg] 0 end]]
  set arg [join [lrange [string map [list %VERSION% $http(version)] $arg] 0 end]]
  return $arg
}

##############################
# Strip colors the idea is
# also to return colors in 
# html but not there yet
##############################

proc stripcolors {arg} {
  set color(0) "#ffffff"; set color(8) "#ffff00" 
  set color(1) "#000000"; set color(9) "#00ff00"
  set color(2) "#00007f"; set color(10) "#006464"
  set color(3) "#007f00"; set color(11) "#00ffff"
  set color(4) "#ff0000"; set color(12) "#0000ff"
  set color(5) "#7f0000"; set color(13) "#c200c2"
  set color(6) "#9f009f"; set color(14) "#7a7a7a"
  set color(7) "#ff7f00"; set color(15) "#a6a6a6"
  set arg [string map {\\ \\\\ \[ \\\[ \] \\\] \{ \\\{ \} \\\} \" \\\" \( \\\( \) \\\)} $arg]
  regsub -all -- {\003[0-9]{0,2}(,[0-9]{0,2})?|\017|\037|\002|\026|\006|\007} $arg {} arg
  return [join [lrange $arg 0 end]]
}

##############################
# Host based login checker
##############################

proc login {ipaddr login passwd} {
  global http
  set rf [open $http(authfile) r]
  while {![eof $rf]} {
    gets $rf x
    if {![string equal -nocase {} $login] && ![string equal -nocase {} $passwd] && [string equal -nocase $login [lindex $x 0]] && [string equal -nocase $passwd  [md5 [lindex $x 1][format %x $http(random)][format %x [clock format [clock seconds] -format {%Y%m%d}]][format %x [ip2longip $ipaddr]]]]} {
      set value 1
    }
  }  
  close $rf
  if {[info exists value]} {
    return 1
  } else {
    return 0
  }
}

##############################
# Create a Ascii map of your
# current botnet
##############################

proc asciimap {space bot} {
  global version
  botnet_uplinks
  return "$bot \(<b>$version</b>\)<br>%n[mapgen $space $bot]"
}

##############################
# Show current uplinks
##############################

proc botnet_uplinks {} {
  global botnet http botnet-nick botnetshare botnetvers
  if {[array exists botnet]} {
    array unset botnet
  }
  set botnet(${botnet-nick}) ${botnet-nick}
  foreach x [botlist] { 
    set botnet([lindex $x 0]) [lindex $x 1]
    set botnetshare([lindex $x 0]) [lindex $x 3]
    set botnetvers([lindex $x 0]) [vrsres [lindex $x 2]]
  }
}

##############################
# Create a Ascii map of your
# current botnet
##############################

proc mapgen {space bot} {
  global botnet botnetshare botnetvers
  foreach botlink [array names botnet] {
    if {![string match $bot $botlink] && [string match $botnet($botlink) $bot]} { 
      if {[info exists downlinks]} {
        lappend downlinks $botlink
      } else {
      	set downlinks $botlink
      }
    }
  }
  if {![info exists downlinks]} { 
    return 
  }
  foreach botlink $downlinks {
    if {[string match $botlink [lindex $downlinks end]]} {
      if {[info exist return]} {
        append return "$space &nbsp;`-$botnetshare($botlink)$botlink \(<b>$botnetvers($botlink)</b>\)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<br>%n"
      } else {
      	set return "$space &nbsp;`-$botnetshare($botlink)$botlink \(<b>$botnetvers($botlink)</b>\)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<br>%n"
      }
      mapgen "$space &nbsp;&nbsp;" $botlink
    } else {
      if {[info exists return]} {
        append return "$space &nbsp;|-$botnetshare($botlink)$botlink \(<b>$botnetvers($botlink)</b>\)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<br>%n"
      } else {
      	set return "$space &nbsp;|-$botnetshare($botlink)$botlink \(<b>$botnetvers($botlink)</b>\)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<br>%n"
      }
      mapgen "$space &nbsp;&nbsp;|-&nbsp;&nbsp;&nbsp;" $botlink
    }
  }
  return ${return}
}

##############################
# Http error 404
##############################

proc ERROR404 {smstime s} {
  global http
  puts $s "HTTP/1.1 404 Not Found\n\
              Date: [clock format [clock seconds] -format {%a, %d %b %Y %T GMT} -gmt 1]\n\
	      Server: Eggdrop http script by Ofloo\n\
	      Last-Modified: [clock format [file atime $http(root)/error/error-404$http(extension)] -format {%a, %d %b %Y %T GMT}]\n\
	      Accept-Ranges: bytes\n\
	      Connection: close\n\
	      Content-Type: text/html; charset=iso-8859-1\n"
  source $http(root)/error/error-404$http(extension)
}

##############################
# Http error 400
##############################

proc ERROR400 {smstime s} {
  global http
  puts $s "HTTP/1.1 400 Bad Request\n\
              Date: [clock format [clock seconds] -format {%a, %d %b %Y %T GMT} -gmt 1]\n\
	      Server: Eggdrop http script by Ofloo\n\
	      Last-Modified: [clock format [file atime $http(root)/error/error-400$http(extension)] -format {%a, %d %b %Y %T GMT}]\n\
	      Accept-Ranges: bytes\n\
	      Connection: close\n\
	      Content-Type: text/html; charset=iso-8859-1\n"
  source $http(root)/error/error-400$http(extension)
}

##############################
# Return uptime in a readable
# format w d h m s
##############################

proc calcuptime {start} {
  set time(uptime) [expr [clock seconds]-$start]
  set time(week) [expr $time(uptime)/604800]
  set time(uptime) [expr $time(uptime)-$time(week)*604800]
  set time(days) [expr $time(uptime)/86400]
  set time(uptime) [expr $time(uptime)-$time(days)*86400]
  set time(hour) [expr $time(uptime)/3600]
  set time(uptime) [expr $time(uptime)-$time(hour)*3600]
  set time(mins) [expr $time(uptime)/60]
  set time(uptime) [expr $time(uptime)-$time(mins)*60]
  set time(secs) $time(uptime)
  set time(return) "$time(week) week\(s\) $time(days) day\(s\) $time(hour) hour\(s\) $time(mins) minute\(s\) $time(secs) second\(s\)."
  return $time(return)
}

##############################
# Return countdown in normal
# format d h m s
##############################

proc countdown {end} {
  set time(uptime) [expr $end-[clock seconds]]
  set time(days) [expr $time(uptime)/86400]
  set time(uptime) [expr $time(uptime)-$time(days)*86400]
  set time(hour) [expr $time(uptime)/3600]
  set time(uptime) [expr $time(uptime)-$time(hour)*3600]
  set time(mins) [expr $time(uptime)/60]
  set time(uptime) [expr $time(uptime)-$time(mins)*60]
  set time(secs) $time(uptime)
  if {($time(days))} {
    set time(return) "$time(days) days"
  } elseif {!($time(days)) && ($time(hour))} {
    set time(return) "$time(hour) hours"
  } elseif {!($time(days)) && !($time(hour)) && ($time(mins))} {
    set time(return) "$time(mins) minutes"
  } elseif {!($time(days)) && !($time(hour)) && !($time(mins)) && ($time(secs))} {
    set time(return) "$time(secs) seconds"
  }
  return $time(return)
}

##############################
# Checks port by using an 
# async socket
##############################

proc portcheck {host port} {
   global done online
   if {[catch {socket $host $port} s]} {
      set online($host) "<font style=\"color:red\">offline</font>"
   } else {
      fileevent $s writable [list checksocket $s $host $port]
      vwait done($s)
   }
}

##############################
# Async check reply
##############################

proc checksocket {s host port} {
   global done online
   if {[fconfigure $s -error]==""} {
      set online($host) "<font style=\"color:green\">online</font>"
   } else {
      set online($host) "<font style=\"color:red\">offline</font>"
   }
   close $s
   set done($s) 1
}


##############################
# Create a longip out an ip
##############################

proc ip2longip {ipaddr} {
  foreach ipbyte [split $ipaddr \x2E] { 
    append hexaddr [format {%02x} $ipbyte] 
  } 
  return [format {%u} "0x$hexaddr"] 
}

##############################
# Reformating num version
##############################

proc vrsres {value} {
  foreach {a b c d e f g} [split $value {}] {
    set vrs "v[format %.0f $a].[format %.0f $b$c].[format %.0f $d$e] $value p[format %.0f $f$g]" 
    break
  }
  return "$vrs"
}

##############################
# Resetting random md5 hash
##############################

proc chhash:dcc {hand idx arg} {
  global http 
  set http(random) [rand 99999]
  putdcc $idx "Changed httpadmin md5 random hash."
}

##############################
# Adding new httpadm user
##############################

proc addusr:dcc {hand idx arg} {
  global http
  set arg [string map {\\ \\\\ \[ \\\[ \] \\\] \{ \\\{ \} \\\} \" \\\" \( \\\( \) \\\)} $arg]
  if {[file exists $http(authfile)]} {
    if {[string equal {} [lindex $arg 1]]} {
      putdcc $idx "Usage: .addusr <username> <password>."
    } else {
      set af [open $http(authfile) a]
      puts $af "[lindex $arg 0] [md5 [lindex $arg 1]]"
      close $af
      putdcc $idx "Added user \(\002[lindex $arg 0]\002\) with pass \(\002[lindex $arg 1]\002\)." 
    }
  } else {
    if {[string equal {} [lindex $arg 1]]} {
      putdcc $idx "Usage: .addusr <username> <password>."
    } else {
      set wf [open $http(authfile) w]
      puts $wf "[lindex $arg 0] [md5 [lindex $arg 1]]"
      close $wf
      putdcc $idx "Added user \(\002[lindex $arg 0]\002\) with pass \(\002[lindex $arg 1]\002\)." 
    }
  }
}

##############################
# Deleting httpadm user
##############################

proc delusr:dcc {hand idx arg} {
  global http
  set arg [string map {\\ \\\\ \[ \\\[ \] \\\] \{ \\\{ \} \\\} \" \\\" \( \\\( \) \\\)} $arg]
  if {[file exists $http(authfile)]} {
    if {[string equal {} [lindex $arg 0]]} {
      putdcc $idx "Usage: .delusr <username>"
    } else {
      set rf [open $http(authfile) r]
      set rd [read $rf]
      close $rf
      set wf [open $http(authfile) w]
      foreach x [split $rd \n] {
        if {![string equal -nocase [lindex $x 0] [lindex $arg 0]]} {
          if {![string equal {} $x]} {
            puts $wf "$x"
	  }
	} else {
	  set usrdel 1
	}
      }
      close $wf
      if {[info exists usrdel]} {
        putdcc $idx "User \(\002[lindex $arg 0]\002\) deleted."
      } else {
      	putdcc $idx "No sutch user."
      }
    }
  } else {
    putdcc $idx "No sutch user."
  }
}

################################################################################
putlog "\002HttpAdmin.tcl\002 by \002Ofloo\002 is loaded version \002$http(version)\002."
